VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "09_4 Ray Pick Action"
   ClientHeight    =   6195
   ClientLeft      =   2370
   ClientTop       =   2790
   ClientWidth     =   6855
   Height          =   6570
   Left            =   2310
   LinkTopic       =   "Form1"
   ScaleHeight     =   6195
   ScaleWidth      =   6855
   Top             =   2475
   Width           =   6975
   Begin VB.Label Label1 
      Caption         =   $"09_4PickAction.frx":0000
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   12
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   1335
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   6735
   End
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   4815
      Left            =   0
      TabIndex        =   0
      Top             =   1320
      Width           =   6855
      _Version        =   131072
      _ExtentX        =   12091
      _ExtentY        =   8493
      _StockProps     =   0
      decorationOn    =   0   'False
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
    Dim conOut As SoOutput
    Dim wAction As SoWriteAction

Private Sub Form_Initialize()
  
    'set up output
    Set wAction = New SoWriteAction
    Set conOut = New SoOutput
    Call conOut.Reset
    Call conOut.setOutputConsole
    Call wAction.setOutput(conOut)
    
    'Create the scene root
    Dim root As SoSeparator
    Set root = New SoSeparator

    'Add an event callback to catch mouse button presses.
    'The callback is set up later on.
    Dim myEventCB As SoEventCallback
    Set myEventCB = New SoEventCallback
    Call root.addChild(myEventCB)

    'Read object data from a file
    Dim mySceneInput As SoInput
    Set mySceneInput = New SoInput
    Dim starObject
    
    Dim idisp As Object
    Set idisp = V3Space1.GetIDispatch
    
    Set starObject = mySceneInput.readAllUrl("examples\data\star.iv", idisp)
    
    If (starObject Is Nothing) Then
        MsgBox "Unable to open star.iv"
        End
    End If
    'Add two copies of the star object, one white and one red
    Dim myRotation As SoRotationXYZ
    Set myRotation = New SoRotationXYZ
    Call myRotation.axis.setValue(0) 'SoRotationXYZ::X)
    Call myRotation.angle.setValue((3.1415 / 2.2))   'almost 90 degrees
    Call root.addChild(myRotation)

    Call root.addChild(starObject)  'first star object

    Dim myMaterial As SoMaterial
    Set myMaterial = New SoMaterial
    Call myMaterial.diffuseColor.setValue(1#, 0#, 0#)       'red
    Call root.addChild(myMaterial)
    Dim myTranslation As SoTranslation
    Set myTranslation = New SoTranslation
    Call myTranslation.translation.setValue(1#, 0#, 1#)
    Call root.addChild(myTranslation)
    Call root.addChild(starObject)  'second star object


    'Turn off viewing to allow picking
    Call V3Space1.setViewing(False)

    Call V3Space1.setSceneRoot(root)

    'Set up the event callback. We want to pass the root of the
    'entire scene graph (including the camera) as the userData,
    'so we get the scene manager's version of the scene graph
    'root.
    Static eCB As SoEventCallbackCB
    Set eCB = New SoEventCallbackCB
    'mouseButton
    eCB.nType = 4
    Set eCB.userDataObject = V3Space1.getEntireSceneGraph
    
    Call myEventCB.addEventCallback(idisp, eCB)
    Call V3Space1.viewAll
    '  SoMouseButtonEvent::getClassTypeId(),
    '  myMousePressCB,
    '  myViewer->getSceneManager()->getSceneGraph());

    Set root = Nothing
    Set mySceneInput = Nothing
    Set starObject = Nothing
    Set myRotation = Nothing
    Set myMaterial = Nothing
    Set myTranslation = Nothing
    Set sceneRoot = Nothing
    Set idisp = Nothing
    
End Sub

Private Sub Form_Terminate()
    Set conOut = Nothing
    Set wAction = Nothing
End Sub

Private Sub V3Space1_MouseButtonEvent(ByVal eventCallbackCB As Object, ByVal eventCallback As Object)

    Dim sceneRoot
   
    Set sceneRoot = V3Space1.getEntireSceneGraph

    '// Check for mouse button being pressed
    'if (SO_MOUSE_PRESS_EVENT(event, ANY)) {
    '   const SbViewportRegion &myRegion =
    '      eventCB->getAction()->getViewportRegion();
    '   writePickedPath(root, myRegion,
    '                   event->getPosition(myRegion));
    '   eventCB->setHandled();
    '}
   
    Dim hEvent As SoHandleEventAction
    Set hEvent = eventCallback.getAction
    Call eventCallback.setHandled
    
    Dim myRegion As SbViewportRegion
    Set myRegion = hEvent.getViewportRegion
    'Set myRegion = V3Space1.getViewportRegion
   
    Dim evt
    Set evt = eventCallback.getEvent
    
    Dim vec2s As SbVec2s
    Set vec2s = evt.getPositionViewport(myRegion)
    Call writePickedPath(eventCallbackCB.userDataObject, myRegion, vec2s)
   

End Sub


Public Sub writePickedPath(ByVal root As SoNode, ByVal viewport As SbViewportRegion, ByVal cursorPosition As SbVec2s)

    Dim myPickAction As SoRayPickAction
    Set myPickAction = New SoRayPickAction
    Call myPickAction.setViewport(viewport)

    'Set an 8-pixel wide region around the pixel
    Call myPickAction.setPoint(cursorPosition)
    Call myPickAction.setRadius(8#)

    'Start a pick traversal
    Call myPickAction.applyNode(root)
    Dim myPickedPoint As SoPickedPoint
    Set myPickedPoint = myPickAction.getPickedPoint(0)
   
    If myPickedPoint Is Nothing Then
      GoTo cleanup
    End If
    
    Dim path As SoPath
    Set path = myPickedPoint.getPath
    
    If (path Is Nothing) Then
        GoTo cleanup
    End If
        
    Call wAction.applyPath(path)
    Call conOut.flushFile

cleanup:
    Set myPickAction = Nothing
    Set path = Nothing
End Sub
