VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4935
   ClientLeft      =   1200
   ClientTop       =   2085
   ClientWidth     =   10275
   Height          =   5310
   Left            =   1140
   LinkTopic       =   "Form1"
   ScaleHeight     =   4935
   ScaleWidth      =   10275
   Top             =   1770
   Width           =   10395
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   3855
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   9975
      _Version        =   131072
      _ExtentX        =   17595
      _ExtentY        =   6800
      _StockProps     =   0
      viewingOn       =   0   'False
      selectionEnable =   -1  'True
      selectionMethod =   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
    Dim selCB As SoSelectionPathCB
    Dim dselCB As SoSelectionPathCB
    Dim pickFilterCB As SoSelectionPickCB

Public Function myText(t As String, i As Integer, c As SbColor) As SoSeparator

    Dim sep As SoSeparator
    Set sep = New SoSeparator
       
    Dim col As SoBaseColor
    Set col = New SoBaseColor
    Dim xf As SoTransform
    Set xf = New SoTransform
    Dim text As SoText3
    Set text = New SoText3
    
    Call col.RGB.setValueColor(c)
    
    Call xf.translation.setValue(6# * i, 0#, 0#)
    Call text.Str.setValue(t)
    Call text.parts.setValue(SoText3_FRONT Or SoText3_SIDES)
    Call text.justification.setValue(SoText3_CENTER)
    Call sep.addChild(col)
    Call sep.addChild(xf)
    Call sep.addChild(text)
   
    Set myText = sep

End Function

Public Function buildScene() As SoSeparator

    Dim root As SoSeparator
    Set root = New SoSeparator
    Dim font As SoFont
    Set font = New SoFont
   
    Call font.Size.setValue(10)
    
    Call root.addChild(font)
   
    Dim c As SbColor
    Set c = New SbColor
    Call c.setValue(0, 0, 1)
    Call root.addChild(myText("O", 0, c))
    Call c.setValue(0, 1, 0)
    Call root.addChild(myText("p", 1, c))
    Call c.setValue(0, 1, 1)
    Call root.addChild(myText("e", 2, c))
    Call c.setValue(1, 0, 0)
    Call root.addChild(myText("n", 3, c))
   '// Open Inventor is two words!
    Call c.setValue(1, 0, 1)
    Call root.addChild(myText("I", 5, c))
    Call c.setValue(1, 1, 0)
    Call root.addChild(myText("n", 6, c))
    Call c.setValue(1, 1, 1)
    Call root.addChild(myText("v", 7, c))
    Call c.setValue(0, 0, 1)
    Call root.addChild(myText("e", 8, c))
    Call c.setValue(0, 1, 0)
    Call root.addChild(myText("n", 9, c))
    Call c.setValue(0, 1, 1)
    Call root.addChild(myText("t", 10, c))
    Call c.setValue(1, 0, 0)
    Call root.addChild(myText("o", 11, c))
    Call c.setValue(1, 0, 1)
    Call root.addChild(myText("r", 12, c))
   
    Set buildScene = root

End Function

Private Sub Form_Initialize()

    Dim root As Object
    
    Set root = buildScene()
    Call V3Space1.setSceneRoot(root)
    Call V3Space1.viewAll
    
    Set selCB = New SoSelectionPathCB
    Set dselCB = New SoSelectionPathCB
    Set pickFilterCB = New SoSelectionPickCB
    
    Dim sceneRoot As SoSelection
    Set sceneRoot = V3Space1.getSceneRoot
    
    Call sceneRoot.addSelectionCallback(V3Space1.GetIDispatch(), selCB)
    Call sceneRoot.addDeselectionCallback(V3Space1.GetIDispatch(), dselCB)
    Call sceneRoot.setPickFilterCallback(V3Space1.GetIDispatch(), pickFilterCB, 0)
    
    Dim box As SoBoxHighlightRenderAction
    Set box = V3Space1.getGLRenderAction
    Call box.setVisible(0)
    
End Sub


Public Function findXForm(p As SoPath) As SoPath

   Dim returnPath As SoPath

   'Copy the input path up to tail's parent.
   Set returnPath = p.Copy(0, p.getLength() - 1)

   'Get the parent of the selected shape
   Dim g As Object
   Set g = p.getNodeFromTail(1)
   Dim tailNodeIndex As Integer
   tailNodeIndex = p.getIndexFromTail(0)
   
   'Check if there is already a transform node
   If (tailNodeIndex > 0) Then
      Dim n As Object
      Set n = g.getChild(tailNodeIndex - 1)
      Dim t As SoTransform
      Set t = New SoTransform
      If n.isOfType(t.getClassTypeId()) Then
        'Append to returnPath and return it.
         Call returnPath.appendNode(n)
         Set findXForm = returnPath
         Exit Function
      End If
   End If
   
   'Otherwise, add a transform node.
   Dim xf As SoTransform
   Set xf = New SoTransform
   Call g.insertChild(xf, tailNodeIndex) 'right before the tail
   'Append to returnPath and return it.
   Call returnPath.Append(xf)
   Set findXForm = returnPath
End Function

Public Function findManip(p As SoPath) As SoPath

    Dim returnPath As SoPath

    'Copy the input path up to tail's parent.
    Set returnPath = p.Copy(0, p.getLength() - 1)

    'Get the index of the last node in the path.
    Dim tailNodeIndex As Integer
    tailNodeIndex = p.getIndexFromTail(0)
   
    'Append the left sibling of the tail to the returnPath
    Call returnPath.Append(tailNodeIndex - 1)
    Set findManip = returnPath
End Function

Private Sub V3Space1_DeselectionCallback(ByVal pathCB As Object, ByVal path As Object)
   
    If path.getLength() < 2 Then
        Exit Sub
    End If
    
    'Find the manipulator affecting this object
    Dim manipPath As SoPath
    Set manipPath = findManip(path)
    Call manipPath.ref
    
    'Replace the manipulator with a transform
    Dim manip As Object
    Set manip = manipPath.getTail()
    Dim t As SoTransform
    Set t = New SoTransform
    Call manip.replaceManip(manipPath, t)

    'Unref the manipPath
    Call manipPath.unref

End Sub

Private Sub V3Space1_SelectionCallback(ByVal pathCB As Object, ByVal path As Object)
   
    If path.getLength() < 2 Then
        Exit Sub
    End If
    
    'Find the transform affecting this object
    Dim xfPath As SoPath
    Set xfPath = findXForm(path)
    Call xfPath.ref
    
    'Replace the transform with a manipulator
    Dim manip As SoHandleBoxManip
    Set manip = New SoHandleBoxManip
    Call manip.ref
    Call manip.replaceNode(xfPath)

    'Unref the xfPath
    Call xfPath.unref

End Sub

Private Sub V3Space1_SelectionPickFilterCallback(ByVal pickCB As Object, ByVal pickedPoint As Object, returnPath As Object)
   
    Dim filteredPath As SoPath
    
    'See if the picked object is a manipulator.
    'If so, change the path so it points to the object the manip
    'is attached to.
    Dim p As SoPath
    Set p = pickedPoint.getPath()
    Dim n As Object
    Set n = p.getTail()
   
    Dim tm As SoTransformManip
    Set tm = New SoTransformManip
    
    If n Is Nothing Then
    
    ElseIf n.isOfType(tm.getClassTypeId()) Then
      'Manip picked! We know the manip is attached
      'to its next sibling. Set up and return that path.
      Dim manipIndex As Integer
      manipIndex = p.getIndex(p.getLength() - 1)
      Set filteredPath = p.Copy(0, p.getLength() - 1)
      Call filteredPath.Append(manipIndex + 1) 'get next sibling
    Else
        Set filteredPath = p
    End If
    
    Set returnPath = filteredPath

End Sub

