VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "12_3 Alarm Sensor"
   ClientHeight    =   5850
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   6390
   Height          =   6225
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   5850
   ScaleWidth      =   6390
   Top             =   1110
   Width           =   6510
   Begin VB.CommandButton Command1 
      Caption         =   "Schedule Alarm Sensor"
      Height          =   1095
      Left            =   1440
      TabIndex        =   2
      Top             =   4680
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "This example uses an SoAlarmSensor to change the rotation of a cone after 3 seconds."
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   12
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   6135
   End
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   3735
      Left            =   0
      TabIndex        =   0
      Top             =   840
      Width           =   6375
      _Version        =   131072
      _ExtentX        =   11245
      _ExtentY        =   6588
      _StockProps     =   0
      decorationOn    =   0   'False
      viewingOn       =   0   'False
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
    Dim myAlarm As SoAlarmSensor
    Dim flagXform As SoTransform



Private Sub Command1_Click()
    
    If myAlarm Is Nothing Then
        GoTo cleanup
    End If
    
    If myAlarm.isScheduled() Then
        GoTo cleanup
    End If
    
    Dim vec3f As SbVec3f
    Set vec3f = New SbVec3f
    Call vec3f.setValue(0, 0, 1)
    Call flagXform.rotation.setValueAxis(vec3f, 0)
    
    Dim t As SbTime
    Set t = New SbTime
    Call t.setValue(3)
    Call myAlarm.setTimeFromNow(t)
        
    Call myAlarm.schedule

cleanup:
    Set vec3f = Nothing
    Set t = Nothing

End Sub

Private Sub Form_Initialize()
   
    Dim root As SoSeparator
    Set root = New SoSeparator
   
    Set flagXform = New SoTransform

    Call root.addChild(flagXform)
    Dim myCone As SoCone
    Set myCone = New SoCone
    Call myCone.bottomRadius.setValue(0.1)
    Call root.addChild(myCone)
    
    Call V3Space1.setSceneRoot(root)
    
    Call V3Space1.viewAll
    
    Static sensorCB As SoSensorCB
    Set sensorCB = New SoSensorCB
    sensorCB.sensorType = 1 'alarmSensor

    'Create an alarm that will call the flag-raising callback:
    Set myAlarm = New SoAlarmSensor
    Dim idisp As Object
    Set idisp = V3Space1.GetIDispatch
    
    Set sensorCB.userDataObject = flagXform
    Call myAlarm.setFunction(idisp, sensorCB)
    
    Dim t As SbTime
    Set t = New SbTime
    Call t.setValue(3)
    
    Call myAlarm.setTimeFromNow(t)
    Call myAlarm.schedule
    
End Sub




Private Sub Form_Unload(Cancel As Integer)
    Set myAlarm = Nothing
    Set flagXform = Nothing

End Sub


Private Sub V3Space1_AlarmSensor(ByVal sensorCB As Object, ByVal sensor As Object)
    
    'We know data is really a SoTransform node:
    Dim flagAngleXform As SoTransform
    Set flagAngleXform = sensorCB.userDataObject

    If flagAngleXform Is Nothing Then
        GoTo cleanup
    End If

    'Rotate flag by 90 degrees about the Z axis:
    Dim vec3f As SbVec3f
    Set vec3f = New SbVec3f
    Call vec3f.setValue(0, 0, 1)
    Call flagAngleXform.rotation.setValueAxis(vec3f, (3.1415 / 2))
        

cleanup:
    Set t = Nothing
    Set sensorCB = Nothing
    Set sensor = Nothing
    Set flagAngleXform = Nothing
    Set vec3f = Nothing
    
End Sub

