VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "14_1 Frolicking Words"
   ClientHeight    =   6015
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   6990
   Height          =   6390
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   6015
   ScaleWidth      =   6990
   Top             =   1110
   Width           =   7110
   Begin VB.Label Label1 
      Caption         =   "This example uses SoShapeKits to create two 3-D words, ""NICE"" and ""HAPPY"""
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   12
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   6615
   End
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   5055
      Left            =   0
      TabIndex        =   0
      Top             =   960
      Width           =   6975
      _Version        =   131072
      _ExtentX        =   12303
      _ExtentY        =   8916
      _StockProps     =   0
      decorationOn    =   0   'False
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Form_Initialize()

    Dim root As SoSeparator
    Set root = New SoSeparator

    'Create shape kits with the words "HAPPY" and "NICE"
    Dim happyKit As SoShapeKit
    Set happyKit = New SoShapeKit
    Call root.addChild(happyKit)
    Dim t3 As SoText3
    Set t3 = New SoText3
    Call happyKit.setPart(utlSbName("shape"), t3)
    Call happyKit.setParam("shape { parts ALL string ""HAPPY""}")
    Call happyKit.setParam("font { size 2}")

    Dim niceKit As SoShapeKit
    Set niceKit = New SoShapeKit
    Call root.addChild(niceKit)
    Set t3 = New SoText3
    Call niceKit.setPart(utlSbName("shape"), t3)
    Call niceKit.setParam("shape { parts ALL string ""NICE""}")
    Call niceKit.setParam("font { size 2}")

    'Create the Elapsed Time engine
    Static myTimer As SoElapsedTime
    Set myTimer = New SoElapsedTime

    'Create two calculator - one for HAPPY, one for NICE.
    Static happyCalc As SoCalculator
    Set happyCalc = New SoCalculator
    Call happyCalc.a.connectFromEngine(myTimer.timeout)
    
    Dim expStr As String
    expStr = "ta=cos(2*a); tb=sin(2*a);"
    expStr = expStr + "oA = vec3f(3*pow(ta,3),3*pow(tb,3),1);"
    expStr = expStr + "oB = vec3f(fabs(ta)+.1,fabs(.5*fabs(tb))+.1,1);"
    expStr = expStr + "oC = vec3f(fabs(ta),fabs(tb),.5)"
    Call happyCalc.expression.setValue(expStr)

    'The second calculator uses different arguments to
    'sin() and cos(), so it moves out of phase.
    Static niceCalc As SoCalculator
    Set niceCalc = New SoCalculator
    Call niceCalc.a.connectFromEngine(myTimer.timeout)
    expStr = "ta=cos(2*a+2); tb=sin(2*a+2);"
    expStr = expStr + "oA = vec3f(3*pow(ta,3),3*pow(tb,3),1);"
    expStr = expStr + "oB = vec3f(fabs(ta)+.1,fabs(.5*fabs(tb))+.1,1);"
    expStr = expStr + "oC = vec3f(fabs(ta),fabs(tb),.5)"
    Call niceCalc.expression.setValue(expStr)

    'Connect the transforms from the calculators...
    Dim happyXf As SoTransform
    Set happyXf = happyKit.getPart(utlSbName("transform"), True)
    
    Call happyXf.translation.connectFromEngine(happyCalc.oAU)
    Call happyXf.scaleFactor.connectFromEngine(happyCalc.oBU)
    
    Dim niceXf As SoTransform
    Set niceXf = niceKit.getPart(utlSbName("transform"), True)
    Call niceXf.translation.connectFromEngine(niceCalc.oAU)
    Call niceXf.scaleFactor.connectFromEngine(niceCalc.oBU)

    'Connect the materials from the calculators...
    Dim happyMtl As SoMaterial
    Set happyMtl = happyKit.getPart(utlSbName("material"), True)
    Call happyMtl.diffuseColor.connectFromEngine(happyCalc.oCU)
    
    Dim niceMtl As SoMaterial
    Set niceMtl = niceKit.getPart(utlSbName("material"), True)
    Call niceMtl.diffuseColor.connectFromEngine(niceCalc.oCU)

    Call V3Space1.setSceneRoot(root)
    Call V3Space1.viewAll

End Sub

