VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "14_3 Balance"
   ClientHeight    =   6495
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   5610
   Height          =   6870
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   6495
   ScaleWidth      =   5610
   Top             =   1110
   Width           =   5730
   Begin VB.Label Label1 
      Caption         =   "This example illustrates the creation on motion hierarchies using nodekits by creating a model of a balance -style scale."
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   12
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   1455
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   5415
   End
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   5175
      Left            =   0
      TabIndex        =   0
      Top             =   1320
      Width           =   5655
      _Version        =   131072
      _ExtentX        =   9975
      _ExtentY        =   9128
      _StockProps     =   0
      decorationOn    =   0   'False
      viewingOn       =   0   'False
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Form_Initialize()
   
    Dim mySceneKit As SoSceneKit
    Set mySceneKit = New SoSceneKit

    Dim myLightKit As SoLightKit
    Set myLightKit = New SoLightKit
    Call mySceneKit.setPart(utlSbName("lightList[0]"), myLightKit)
    Dim myCameraKit As SoCameraKit
    Set myCameraKit = New SoCameraKit
    Call mySceneKit.setPart(utlSbName("cameraList[0]"), myCameraKit)
    Call mySceneKit.setCameraNumber(0)

    'Create the Balance Scale -- put each part in the
    ' childList of its parent, to build up this hierarchy:
    '
    '                    myScene
    '                       |
    '                     support
    '                       |
    '                     beam
    '                       |
    '                   --------
    '                   |       |
    '                string1  string2
    '                   |       |
    '                tray1     tray2

    Dim support As SoShapeKit
    Set support = New SoShapeKit
    Dim myCone As SoCone
    Set myCone = New SoCone
    Call support.setPart(utlSbName("shape"), myCone)
    Call support.setParam("shape { height 3 bottomRadius .3 }")
    Call mySceneKit.setPart(utlSbName("childList[0]"), support)

    Dim beam As SoShapeKit
    Set beam = New SoShapeKit
    Set myCube = New SoCube
    Call beam.setPart(utlSbName("shape"), myCube)
    Call beam.setParam("shape { width 3 height .2 depth .2 }")
    Call beam.setParam("transform { translation 0 1.5 0 } ")
    Call support.setPart(utlSbName("childList[0]"), beam)

    Dim string1 As SoShapeKit
    Set string1 = New SoShapeKit
    Dim myCylinder As SoCylinder
    Set myCylinder = New SoCylinder
    Call string1.setPart(utlSbName("shape"), myCylinder)
    Call string1.setParam("shape { radius .05 height 2}")
    Call string1.setParam("transform { translation -1.5 -1 0 }")
    Call string1.setParam("transform { center 0 1 0 }")
    Call beam.setPart(utlSbName("childList[0]"), string1)

    Dim string2 As SoShapeKit
    Set string2 = New SoShapeKit
    Set myCylinder = New SoCylinder
    Call string2.setPart(utlSbName("shape"), myCylinder)
    Call string2.setParam("shape { radius .05 height 2}")
    Call string2.setParam("transform { translation 1.5 -1 0 } ")
    Call string2.setParam("transform { center 0 1 0 } ")
    Call beam.setPart(utlSbName("childList[1]"), string2)

    Dim tray1 As SoShapeKit
    Set tray1 = New SoShapeKit
    Set myCylinder = New SoCylinder
    Call tray1.setPart(utlSbName("shape"), myCylinder)
    Call tray1.setParam("shape { radius .75 height .1 }")
    Call tray1.setParam("transform { translation 0 -1 0 } ")
    Call string1.setPart(utlSbName("childList[0]"), tray1)

    Dim tray2 As SoShapeKit
    Set tray2 = New SoShapeKit
    Set myCylinder = New SoCylinder
    Call tray2.setPart(utlSbName("shape"), myCylinder)
    Call tray2.setParam("shape { radius .75 height .1 }")
    Call tray2.setParam("transform { translation 0 -1 0 } ")
    Call string2.setPart(utlSbName("childList[0]"), tray2)

    'Add EventCallback so Balance Responds to Events
    Dim myCallbackNode As SoEventCallback
    Set myCallbackNode = New SoEventCallback
    
    Static eCB As SoEventCallbackCB
    Set eCB = New SoEventCallbackCB
    eCB.nType = SoEventCallbackCB_KEYBOARD
    Set eCB.userDataObject = support
    Call myCallbackNode.addEventCallback(V3Space1.GetIDispatch(), eCB)
    
    Call support.setPart(utlSbName("callbackList[0]"), myCallbackNode)

    'Add Instructions as Text in the Scene...
    Dim myText As SoShapeKit
    Set myText = New SoShapeKit
    Dim t2 As SoText2
    Set t2 = New SoText2
    Call myText.setPart(utlSbName("shape"), t2)
    Call myText.setParam("shape { string ""Press Shift+Left or Shift+Right Arrow Key"" }")
    Call myText.setParam("shape { justification CENTER }")
    Call myText.setParam("font { name ""Helvetica-Bold"" }")
    Call myText.setParam("font { size 16.0 }")
    Call myText.setParam("transform { translation 0 -2.5 0 }")
    Call mySceneKit.setPart(utlSbName("childList[1]"), myText)

    Call V3Space1.setSceneRoot(mySceneKit)

    'Get camera from scene and tell it to viewAll...
    Dim myCamera As SoPerspectiveCamera
    Set myCamera = New SoPerspectiveCamera
    Set myCamera = mySceneKit.SoGetPart(mySceneKit, utlSbName("cameraList[0].camera"), myCamera.getClassTypeId())

    Call V3Space1.setCurrentCamera(myCamera)
    Call V3Space1.viewAll

End Sub

Private Sub V3Space1_KeyboardEvent(ByVal eventCallbackCB As Object, ByVal eventCallback As Object)
   
    On Error Resume Next

    Dim ev As SoKeyboardEvent
    
    Set ev = eventCallback.getEvent()
    Dim key As Long
    key = ev.getKey()
    If key <> RIGHT_ARROW And key <> LEFT_ARROW Then
        GoTo cleanup
    End If
    
    'Which Key was pressed?
    'If Right or Left Arrow key, then continue...
    Dim support, beam1, string1, string2 As SoShapeKit
    Dim startRot, beamIncrement, stringIncrement As SbRotation
    Set startRot = New SbRotation
    Set beamIncrement = New SbRotation
    Set stringIncrement = New SbRotation
    
    'Get the different nodekits from the userData.
    Set support = eventCallbackCB.userDataObject

    'These three parts are extracted based on knowledge of the
    'motion hierarchy (see the diagram in the main routine.
    Set beam1 = support.getPart(utlSbName("childList[0]"), True)
    Set string1 = beam1.getPart(utlSbName("childList[0]"), True)
    Set string2 = beam1.getPart(utlSbName("childList[1]"), True)

    'Set angular increments to be .1 Radians about the Z-Axis
    'The strings rotate opposite the beam, and the two types
    'of key press produce opposite effects.
    If (key = RIGHT_ARROW) Then
         Call beamIncrement.setValue(utlSbVec3f(0, 0, 1), -0.1)
         Call stringIncrement.setValue(utlSbVec3f(0, 0, 1), 0.1)
    Else
         Call beamIncrement.setValue(utlSbVec3f(0, 0, 1), 0.1)
         Call stringIncrement.setValue(utlSbVec3f(0, 0, 1), -0.1)
    End If

    'Use SO_GET_PART to find the transform for each of the
    'rotating parts and modify their rotations.
    Dim xf As SoTransform
    Set xf = New SoTransform
    Set xf = beam1.SoGetPart(beam1, utlSbName("transform"), xf.getClassTypeId())
    Set startRot = xf.rotation.getValue()
    
    Call startRot.multiply(beamIncrement)
    Call xf.rotation.setValue(startRot)

    Set xf = string1.SoGetPart(string1, utlSbName("transform"), xf.getClassTypeId())
    Set startRot = xf.rotation.getValue()
    Call startRot.multiply(stringIncrement)
    Call xf.rotation.setValue(startRot)

    Set xf = string2.SoGetPart(string2, utlSbName("transform"), xf.getClassTypeId())
    Set startRot = xf.rotation.getValue()
    Call startRot.multiply(stringIncrement)
    Call xf.rotation.setValue(startRot)
    Call eventCallback.setHandled
    
cleanup:
    Set ev = Nothing
    Set eventCallbackCB = Nothing
    Set eventCallback = Nothing
   
   

End Sub

