VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7785
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   6960
   Height          =   8160
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   7785
   ScaleWidth      =   6960
   Top             =   1110
   Width           =   7080
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   4815
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   6615
      _Version        =   131072
      _ExtentX        =   11668
      _ExtentY        =   8493
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Dim root As SoSeparator
Dim myHandleBox As SoHandleBoxManip
Dim myTrackball As SoTrackballManip
Dim myTransformBox As SoTransformBoxManip
Dim handleBoxPath As SoPath
Dim trackballPath As SoPath
Dim transformBoxPath As SoPath

Dim selCB As SoSelectionPathCB
Dim dselCB As SoSelectionPathCB

Dim myWrapperKit As SoWrapperKit
Dim cube As SoCube
Dim sphere As SoSphere

Private Sub Form_Load()

    'create and set up the selection node
    Dim selectionRoot As SoSelection
    Set selectionRoot = V3Space1.getSceneRoot
    
    Set selCB = New SoSelectionPathCB
    Set dselCB = New SoSelectionPathCB
    
    Call selectionRoot.addSelectionCallback(V3Space1.GetIDispatch(), selCB)
    Call selectionRoot.addDeselectionCallback(V3Space1.GetIDispatch(), dselCB)
    

    'create the scene graph
    Set root = New SoSeparator
    Call selectionRoot.addChild(root)

    'Read a file into contents of SoWrapperKit
    'Translate it to the right.
    Set myWrapperKit = New SoWrapperKit
    Call root.addChild(myWrapperKit)
   
    Dim objectFromFile As Object
    Set objectFromFile = utlReadFile(V3Space1.getRegistryDataPath() + "\examples\data\luxo.iv", V3Space1.GetIDispatch())
   
   
    Call myWrapperKit.setPart(utlSbName("contents"), objectFromFile)
    Call myWrapperKit.setParam("transform { translation 3 -1 0 }")
    Dim wrapperMat As SoMaterial
    Set wrapperMat = myWrapperKit.getPart(utlSbName("material"), True)
   
    Call wrapperMat.diffuseColor.setValue(0.8, 0.8, 0.8)

    'Create a cube with its own transform.
    Dim cubeRoot As SoSeparator
    Set cubeRoot = New SoSeparator
    Dim cubeXform As SoTransform
    Set cubeXform = New SoTransform
    Call cubeXform.translation.setValue(-4, 0, 0)
    Call root.addChild(cubeRoot)
    Call cubeRoot.addChild(cubeXform)

    Dim cubeMat As SoMaterial
    Set cubeMat = New SoMaterial
    Call cubeMat.diffuseColor.setValue(0.8, 0.8, 0.8)
    Call cubeRoot.addChild(cubeMat)
    Set cube = New SoCube
    Call cubeRoot.addChild(cube)

    'add a sphere node without a transform
    '(one will be added when we attach the manipulator)
    Dim sphereRoot As SoSeparator
    Set sphereRoot = New SoSeparator
    Dim sphereMat As SoMaterial
    Set sphereMat = New SoMaterial
    Call root.addChild(sphereRoot)
    Call sphereRoot.addChild(sphereMat)
    Set sphere = New SoSphere
    Call sphereRoot.addChild(sphere)
    Call sphereMat.diffuseColor.setValue(0.8, 0.8, 0.8)

    'create the manipulators
    Set myHandleBox = New SoHandleBoxManip
    Set myTrackball = New SoTrackballManip
    Set myTransformBox = New SoTransformBoxManip

    'Get the draggers and add callbacks to them. Note
    'that you don't put callbacks on manipulators. You put
    'them on the draggers which handle events for them.
    Dim myDragger As Object 'SoDragger
    Set myDragger = myTrackball.getDragger()
    
    Static dragStartCB As SoDraggerStartCB
    Set dragStartCB = New SoDraggerStartCB
    dragStartCB.userDataObject = cubeMat
    Call myDragger.addStartCallback(dragStartCB, V3Space1.GetIDispatch())
    
    Static dragFinishCB As SoDraggerFinishCB
    Set dragFinishCB = New SoDraggerFinishCB
    dragFinishCB.userDataObject = cubeMat
    Call myDragger.addFinishCallback(dragFinishCB, V3Space1.GetIDispatch())

    Set myDragger = myHandleBox.getDragger()
    
    Static dragStartCB2 As SoDraggerStartCB
    Set dragStartCB2 = New SoDraggerStartCB
    dragStartCB2.userDataObject = sphereMat
    Call myDragger.addStartCallback(dragStartCB2, V3Space1.GetIDispatch())
    
    Static dragFinishCB2 As SoDraggerFinishCB
    Set dragFinishCB2 = New SoDraggerFinishCB
    dragFinishCB2.userDataObject = sphereMat
    Call myDragger.addFinishCallback(dragFinishCB2, V3Space1.GetIDispatch())
    

    Set myDragger = myTransformBox.getDragger()
    
    Static dragStartCB3 As SoDraggerStartCB
    Set dragStartCB3 = New SoDraggerStartCB
    dragStartCB3.userDataObject = wrapperMat
    Call myDragger.addStartCallback(dragStartCB3, V3Space1.GetIDispatch())
    
    Static dragFinishCB3 As SoDraggerFinishCB
    Set dragFinishCB3 = New SoDraggerFinishCB
    dragFinishCB3.userDataObject = wrapperMat
    
    Call myDragger.addFinishCallback(dragFinishCB3, V3Space1.GetIDispatch())
    'myViewer->setSceneGraph(selectionRoot);
    
    Dim ra As SoBoxHighlightRenderAction
    
    Set ra = V3Space1.getGLRenderAction
    
    Call ra.setVisible(False)
    
    Call V3Space1.viewAll


End Sub


Private Sub Form_Terminate()

    Set root = Nothing
    Set myHandleBox = Nothing
    Set myTrackball = Nothing
    Set myTransformBox = Nothing
    Set handleBoxPath = Nothing
    Set trackballPath = Nothing
    Set transformBoxPath = Nothing

    Set selCB = Nothing
    Set dselCB = Nothing

    Set myWrapperKit = Nothing
    Set cube = Nothing
    Set sphere = Nothing

End Sub


Private Sub V3Space1_DeselectionCallback(ByVal pathCB As Object, ByVal path As Object)
   
    Dim tail As Object
    Set tail = path.getTail()
    
    If tail.isOfType(sphere.getClassTypeId) Then
        Call myHandleBox.replaceManip(handleBoxPath, Nothing)
        Set handleBoxPath = Nothing
   ElseIf (tail.isOfType(cube.getClassTypeId())) Then
        Call myTrackball.replaceManip(trackballPath, Nothing)
        Set trackballPath = Nothing
   ElseIf (tail.isOfType(myWrapperKit.getClassTypeId())) Then
        Call myTransformBox.replaceManip(transformBoxPath, Nothing)
        Set transformBoxPath = Nothing
   End If

End Sub

Private Sub V3Space1_DraggerFinish(ByVal draggerFinishCB As Object, ByVal dragger As Object)
   
    If Not draggerFinishCB Is Nothing Then
        Call draggerFinishCB.userDataObject.diffuseColor.setValue(0.8, 0.8, 0.8)
    End If

End Sub

Private Sub V3Space1_DraggerStart(ByVal draggerStartCB As Object, ByVal dragger As Object)

    If Not draggerStartCB Is Nothing Then
        Call draggerStartCB.userDataObject.diffuseColor.setValue(1, 0.2, 0.2)
    End If

End Sub


Private Sub V3Space1_SelectionCallback(ByVal pathCB As Object, ByVal path As Object)
    'Attach the manipulator.
    'Use the convenience routine to get a path to
    'the transform that effects the selected object.
    Dim xformPath As SoPath
    Set xformPath = createTransformPath(path)
    If (xformPath Is Nothing) Then
        Exit Sub
    End If
    

    'Attach the handle box to the sphere,
    'the trackball to the cube
    'or the transformBox to the wrapperKit
    
    Dim tail As Object
    Set tail = path.getTail()
    
    If tail.isOfType(sphere.getClassTypeId()) Then
        Set handleBoxPath = xformPath
        Call myHandleBox.replaceNode(xformPath)
    ElseIf tail.isOfType(cube.getClassTypeId()) Then
        Set trackballPath = xformPath
        Call myTrackball.replaceNode(xformPath)
   ElseIf (tail.isOfType(myWrapperKit.getClassTypeId())) Then
        Set transformBoxPath = xformPath
        Call myTransformBox.replaceNode(xformPath)
   End If

End Sub

Public Function createTransformPath(inputPath As SoPath) As SoPath
   
    Dim pathLength As Long
  
    pathLength = inputPath.getLength()
    If (pathLength < 2) Then 'Won't be able to get parent of tail
        Set createTransformPath = Nothing
        Exit Function
    End If

    Dim tail As Object
    Set tail = inputPath.getTail()

    'CASE 1: The tail is a node kit.
    'Nodekits have built in policy for creating parts.
    'The kit copies inputPath, then extends it past the
    'kit all the way down to the transform. It creates the
    'transform if necessary.
    If Not (tail.isOfType(myWrapperKit.getClassTypeId()) = 0) Then
        Set createTransformPath = tail.createPathToPart(utlSbName("transform"), True, inputPath)
        Exit Function
    End If

    Dim editXf As SoTransform
    Dim parent As Object
    Dim existedBefore As Boolean
    existedBefore = False

    'CASE 2: The tail is not a group.
    Dim group As SoGroup
    Set group = New SoGroup
    
    Dim i As Integer
    Dim myNode As Object
    Dim tempXF As SoTransform
    Set tempXF = New SoTransform
    
    Dim isTailGroup As Boolean
    isTailGroup = (tail.isOfType(group.getClassTypeId()) = 1)
    If Not tail.isOfType(group.getClassTypeId()) Then
        ''parent' is node above tail. Search under parent right
        'to left for a transform. If we find a 'movable' node
        'insert a transform just left of tail.
        Set parent = inputPath.getNode(pathLength - 2)
        Dim tailIndx As Long
        tailIndx = parent.findChild(tail)
        For i = tailIndx To 0 Step -1
            Set myNode = parent.getChild(i)
            If myNode.isOfType(tempXF.getClassTypeId()) Then
                Set editXf = myNode
                Exit For
            ElseIf (Not i = tailIndx) And isTransformable(myNode) Then
                Exit For
            End If
        Next
        If (editXf Is Nothing) Then
            existedBefore = False
            Set editXf = New SoTransform
            Call parent.insertChild(editXf, tailIndx)
        Else
            existedBefore = True
        End If
    '// CASE 3: The tail is a group.
    Else
        'Search the children from left to right for transform
        'nodes. Stop the search if we come to a movable node.
        'and insert a transform before it.
        Set parent = tail
        For i = 0 To (parent.getNumChildren() - 1) Step 1
            If Not editXf Is Nothing Then
                Exit For
            End If
            Set myNode = parent.getChild(i)
            If myNode.isOfType(tempXF.getClassTypeId()) Then
                Set editXf = myNode
            ElseIf isTransformable(myNode) Then
                Exit For
            End If
        Next
        If (editXf Is Nothing) Then
            existedBefore = False
            Set editXf = New SoTransform
            Call parent.insertChild(editXf, i)
        Else
          existedBefore = True
        End If
    End If

    'Create 'pathToXform.' Copy inputPath, then make last
    'node be editXf.
    Dim pathToXform As SoPath
   
    Set pathToXform = inputPath.Copy(0, 0)
    If (Not isTailGroup) Then 'pop off the last entry.
        Call pathToXform.pop
    End If
    'add editXf to the end
    Dim xfIndex As Long
    xfIndex = parent.findChild(editXf)
    Call pathToXform.Append(xfIndex)

    Set createTransformPath = pathToXform

End Function

Public Function isTransformable(myNode As Object) As Boolean

Static group As SoGroup
'Static shape As SoShape
Static cam1 As SoPerspectiveCamera
Static cam2 As SoOrthographicCamera
Static directLight As SoDirectionalLight
Static pointLight As SoPointLight
Static spotLight As SoSpotLight

    If group Is Nothing Then
        Set group = New SoGroup
        Set cam1 = New SoPerspectiveCamera
        Set cam2 = New SoOrthographicCamera
        Set directLight = New SoDirectionalLight
        Set pointLight = New SoPointLight
        Set spotLight = New SoSpotLight
    End If
    If myNode.isOfType(group.getClassTypeId()) Or myNode.isOfType(cube.getClassTypeId()) Or myNode.isOfType(cam1.getClassTypeId()) Or myNode.isOfType(cam2.getClassTypeId()) Or myNode.isOfType(sphere.getClassTypeId()) Then
        isTransformable = True
    ElseIf myNode.isOfType(directLight.getClassTypeId()) Or myNode.isOfType(pointLight.getClassTypeId()) Or myNode.isOfType(spotLight.getClassTypeId()) Then
        isTransformable = True
    Else
        isTransformable = False
    End If
End Function
